
_Send_LCD_Data:

;Konami_Drivers.mbas,20 :: 		j as byte
;Konami_Drivers.mbas,22 :: 		for i = Words to 1 step -1                      'Do requested word count
	MOVF        FARG_Send_LCD_Data_Words+0, 0 
	MOVWF       R4 
	MOVLW       1
	SUBWF       FARG_Send_LCD_Data_Words+0, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L__Send_LCD_Data5
L__Send_LCD_Data2:
;Konami_Drivers.mbas,23 :: 		for j = Bits to 1 step -1                     'Do Requested bits per word MSB first
	MOVF        FARG_Send_LCD_Data_Bits+0, 0 
	MOVWF       R5 
	MOVLW       1
	SUBWF       FARG_Send_LCD_Data_Bits+0, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L__Send_LCD_Data10
L__Send_LCD_Data7:
;Konami_Drivers.mbas,24 :: 		PortC.0 = Test_Data.(j-1)                    'Set the data bit
	DECF        R5, 0 
	MOVWF       R0 
	MOVF        R0, 0 
	MOVWF       R2 
	MOVLW       1
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        R2, 0 
L__Send_LCD_Data37:
	BZ          L__Send_LCD_Data38
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	ADDLW       255
	GOTO        L__Send_LCD_Data37
L__Send_LCD_Data38:
	MOVF        R0, 0 
	ANDWF       _Test_Data+0, 0 
	MOVWF       R2 
	MOVF        _Test_Data+1, 0 
	ANDWF       R1, 0 
	MOVWF       R3 
	CLRF        R1 
	MOVLW       0
	XORWF       R3, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Send_LCD_Data39
	MOVLW       0
	XORWF       R2, 0 
L__Send_LCD_Data39:
	BTFSC       STATUS+0, 2 
	GOTO        L__Send_LCD_Data11
	MOVLW       1
	MOVWF       R1 
L__Send_LCD_Data11:
	BTFSC       R1, 0 
	GOTO        L__Send_LCD_Data40
	BCF         PORTC+0, 0 
	GOTO        L__Send_LCD_Data41
L__Send_LCD_Data40:
	BSF         PORTC+0, 0 
L__Send_LCD_Data41:
;Konami_Drivers.mbas,25 :: 		PortC.1 = 1                                  'clock it in
	BSF         PORTC+0, 1 
;Konami_Drivers.mbas,26 :: 		PortC.1 = 0                                  'and drop your clock
	BCF         PORTC+0, 1 
;Konami_Drivers.mbas,27 :: 		next j
	MOVF        R5, 0 
	XORLW       1
	BTFSC       STATUS+0, 2 
	GOTO        L__Send_LCD_Data10
	MOVLW       255
	ADDWF       R5, 1 
	GOTO        L__Send_LCD_Data7
L__Send_LCD_Data10:
;Konami_Drivers.mbas,28 :: 		next i
	MOVF        R4, 0 
	XORLW       1
	BTFSC       STATUS+0, 2 
	GOTO        L__Send_LCD_Data5
	MOVLW       255
	ADDWF       R4, 1 
	GOTO        L__Send_LCD_Data2
L__Send_LCD_Data5:
;Konami_Drivers.mbas,29 :: 		PortC.2 = 1                                 'Raise Latch Enable
	BSF         PORTC+0, 2 
;Konami_Drivers.mbas,30 :: 		PortC.2 = 0                                 'and drop the latch
	BCF         PORTC+0, 2 
;Konami_Drivers.mbas,31 :: 		end sub
L_end_Send_LCD_Data:
	RETURN      0
; end of _Send_LCD_Data

_Flash:

;Konami_Drivers.mbas,33 :: 		Sub Procedure Flash
;Konami_Drivers.mbas,35 :: 		Test_Data_Save = Test_Data                     'Save what were doing
	MOVF        _Test_Data+0, 0 
	MOVWF       _Test_Data_Save+0 
	MOVF        _Test_Data+1, 0 
	MOVWF       _Test_Data_Save+1 
;Konami_Drivers.mbas,36 :: 		Test_Data = Off
	MOVLW       _OFF
	MOVWF       _Test_Data+0 
	MOVLW       _OFF+1
	MOVWF       _Test_Data+1 
;Konami_Drivers.mbas,37 :: 		Send_LCD_DATA (Complete_Buffer,Bit_Count)
	MOVLW       _Complete_Buffer
	MOVWF       FARG_Send_LCD_Data_Words+0 
	MOVLW       _Bit_Count
	MOVWF       FARG_Send_LCD_Data_Bits+0 
	CALL        _Send_LCD_Data+0, 0
;Konami_Drivers.mbas,38 :: 		Test_Data = Test_Data_Save
	MOVF        _Test_Data_Save+0, 0 
	MOVWF       _Test_Data+0 
	MOVF        _Test_Data_Save+1, 0 
	MOVWF       _Test_Data+1 
;Konami_Drivers.mbas,39 :: 		end sub
L_end_Flash:
	RETURN      0
; end of _Flash

_Delay_For_Key:

;Konami_Drivers.mbas,41 :: 		Sub Procedure Delay_For_Key (dim Time as word)    'Wait 1.5 seconds or a Key E.0 Press
;Konami_Drivers.mbas,42 :: 		for Key_Timer = 0 to Time                      'This will be @ 1.5 secondas
	CLRF        _key_timer+0 
	CLRF        _key_timer+1 
L__Delay_For_Key14:
	MOVF        _key_timer+1, 0 
	SUBWF       FARG_Delay_For_Key_Time+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Delay_For_Key44
	MOVF        _key_timer+0, 0 
	SUBWF       FARG_Delay_For_Key_Time+0, 0 
L__Delay_For_Key44:
	BTFSS       STATUS+0, 0 
	GOTO        L__Delay_For_Key18
;Konami_Drivers.mbas,43 :: 		delay_ms (2)                               'of 2 ms + time to read key
	MOVLW       42
	MOVWF       R12, 0
	MOVLW       141
	MOVWF       R13, 0
L__Delay_For_Key19:
	DECFSZ      R13, 1, 1
	BRA         L__Delay_For_Key19
	DECFSZ      R12, 1, 1
	BRA         L__Delay_For_Key19
	NOP
	NOP
;Konami_Drivers.mbas,44 :: 		if BUTTON (PORTE, 0, 5, 1)                 'Look for the press
	MOVLW       PORTE+0
	MOVWF       FARG_Button_port+0 
	MOVLW       hi_addr(PORTE+0)
	MOVWF       FARG_Button_port+1 
	CLRF        FARG_Button_pin+0 
	MOVLW       5
	MOVWF       FARG_Button_time+0 
	MOVLW       1
	MOVWF       FARG_Button_activeState+0 
	CALL        _Button+0, 0
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__Delay_For_Key21
;Konami_Drivers.mbas,46 :: 		While Button (PORTE, 0, 5, 1)            'Got a press wait for it to be released
L__Delay_For_Key24:
	MOVLW       PORTE+0
	MOVWF       FARG_Button_port+0 
	MOVLW       hi_addr(PORTE+0)
	MOVWF       FARG_Button_port+1 
	CLRF        FARG_Button_pin+0 
	MOVLW       5
	MOVWF       FARG_Button_time+0 
	MOVLW       1
	MOVWF       FARG_Button_activeState+0 
	CALL        _Button+0, 0
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__Delay_For_Key25
;Konami_Drivers.mbas,47 :: 		nop
	NOP
;Konami_Drivers.mbas,48 :: 		Wend
	GOTO        L__Delay_For_Key24
L__Delay_For_Key25:
;Konami_Drivers.mbas,49 :: 		Key = 1                                  'Return the keypress
	MOVLW       1
	MOVWF       _key+0 
;Konami_Drivers.mbas,50 :: 		exit                                     'bugger off
	GOTO        L_end__Delay_For_Key
L__Delay_For_Key21:
;Konami_Drivers.mbas,52 :: 		if BUTTON (PORTE, 1, 5, 1)                  'Look for the press of E.1
	MOVLW       PORTE+0
	MOVWF       FARG_Button_port+0 
	MOVLW       hi_addr(PORTE+0)
	MOVWF       FARG_Button_port+1 
	MOVLW       1
	MOVWF       FARG_Button_pin+0 
	MOVLW       5
	MOVWF       FARG_Button_time+0 
	MOVLW       1
	MOVWF       FARG_Button_activeState+0 
	CALL        _Button+0, 0
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__Delay_For_Key29
;Konami_Drivers.mbas,54 :: 		While Button (PORTE, 1, 5, 1)            'Got a press wait for it to be released
L__Delay_For_Key32:
	MOVLW       PORTE+0
	MOVWF       FARG_Button_port+0 
	MOVLW       hi_addr(PORTE+0)
	MOVWF       FARG_Button_port+1 
	MOVLW       1
	MOVWF       FARG_Button_pin+0 
	MOVLW       5
	MOVWF       FARG_Button_time+0 
	MOVLW       1
	MOVWF       FARG_Button_activeState+0 
	CALL        _Button+0, 0
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__Delay_For_Key33
;Konami_Drivers.mbas,55 :: 		nop
	NOP
;Konami_Drivers.mbas,56 :: 		Wend
	GOTO        L__Delay_For_Key32
L__Delay_For_Key33:
;Konami_Drivers.mbas,57 :: 		Key = 2                                  'Return the keypress of E.1
	MOVLW       2
	MOVWF       _key+0 
;Konami_Drivers.mbas,58 :: 		exit                                     'bugger off
	GOTO        L_end__Delay_For_Key
L__Delay_For_Key29:
;Konami_Drivers.mbas,60 :: 		next Key_Timer
	MOVF        _key_timer+1, 0 
	XORWF       FARG_Delay_For_Key_Time+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Delay_For_Key45
	MOVF        FARG_Delay_For_Key_Time+0, 0 
	XORWF       _key_timer+0, 0 
L__Delay_For_Key45:
	BTFSC       STATUS+0, 2 
	GOTO        L__Delay_For_Key18
	INFSNZ      _key_timer+0, 1 
	INCF        _key_timer+1, 1 
	GOTO        L__Delay_For_Key14
L__Delay_For_Key18:
;Konami_Drivers.mbas,61 :: 		Key = 0                                        'Flag no key
	CLRF        _key+0 
;Konami_Drivers.mbas,62 :: 		end sub
L_end__Delay_For_Key:
L_end_Delay_For_Key:
	RETURN      0
; end of _Delay_For_Key
